Page MenuHomePhabricator

[Segmentation] Improve Region Growing 2D algorithm and interaction
Open, NormalPublic

Description

After T27085 Region Growing 2D sometimes shows odd behavior

--> The mouse cursor is released but still more foreground pixels are added
--> This often causes an oversegmentation

tested on US4DCyl

Event Timeline

thomass triaged this task as High priority.Aug 27 2020, 8:28 AM
thomass created this task.
floca moved this task from Backlog to Segmentation on the MITK (2020) board.Sep 2 2020, 10:41 AM
floca added a project: Missing Info.

We talked about this task in the group-5 meeting. It turned out that no more foreground pixels are added after the mouse button was released but that it is just a little slow on the test computer and the latest feedback contour wasn't yet calculated when the mouse button was released. So, not really a bug in my opinion. At least nothing new, since the algorithm of the tool did not change.

There are fundamental problems with the tool though that are related like the calculation of the feedback contour which takes up most of the total calculation time. I tested the tool with a preview segmentation instead not long ago and it is very fast (including the benefit of seeing the preview in the 3d render window). However, this introduced other side effects since the feedback contour calculation "accidentally" smoothes out small holes since it does not support holes at all. If we change this tool to use a preview segmentation instead, we should smooth the input image of the region growing filter, just like it is shown in the ITK guide.

I also noticed that in US4DCyl when just clicking a rather bright spot nothing is initially segmented. In Pic3D when adjusting the level window to have an overexposed appearance it is the same.

Last but not least is the control of the tool very unintuitive. We just discovered by accident that there is a difference in moving the mouse left/right vs. up/down (level window width vs. level window position). We really should consider adding controls to the tool to adjust the position for example and restrict the mouse interaction to width. Probably we would need to add both parameters as controls as adjusting the level window width with mouse movement is suboptimal as well. We cannot intuitively expose better control over the lower vs. upper level window range, making the resulting segmentation highly dependent on the initially clicked pixel/seed and hence sensitive to noise.

kislinsk renamed this task from [Segmentation] Region Growing 2D now tends to oversegmentation to [Segmentation] Improve Region Growing 2D algorithm and interaction.Sep 3 2020, 7:58 AM
kislinsk lowered the priority of this task from High to Normal.
kislinsk removed a project: Missing Info.